package cdac.medinfo.sdk.dcm30_04.services.RTIonMachineVerification.testcases.customizedscp;


import java.net.InetSocketAddress;

import cdac.medinfo.sdk.dcm30_04.baselibs.SQ;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IItem;
import cdac.medinfo.sdk.dcm30_04.enums.EnumCommandField;
import cdac.medinfo.sdk.dcm30_04.enums.EnumLoggingLevel;
import cdac.medinfo.sdk.dcm30_04.enums.EnumPDUType;
import cdac.medinfo.sdk.dcm30_04.services.association.AReleaseRQorRP;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociateRQ;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociationNegotiator;
import cdac.medinfo.sdk.dcm30_04.services.association.DefaultAssociation;
import cdac.medinfo.sdk.dcm30_04.services.association.IDIMSEAssociation;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumDataSource;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumSCEventTypeID;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumServiceType;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.DIMSEResponse;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.IDataSource;
import cdac.medinfo.sdk.dcm30_04.services.neventreport.scu.NEventReportSCU;
import cdac.medinfo.sdk.dcm30_04.services.nget.scp.NGetSCP;
import cdac.medinfo.sdk.dcm30_04.services.rtmachineverificationservice.rtsourceimpl.RTMachineVerification_SourceImpl;
import cdac.medinfo.sdk.dcm30_04.services.scp.commons.ClientSession;
import cdac.medinfo.sdk.dcm30_04.services.scp.commons.ProcessHandler;
import cdac.medinfo.sdk.dcm30_04.services.scp.commons.SCPSession;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.ICollectionIterator;

/**
 * This is the customized implementation of the test code for RT Ion Machine Verification N-Get Service.
 * This sample codes is to show how user can define its own implementation for handling connection, association and service request.
 * In this sample test code all the required methods of IProcessHandler are implemented (onConnect(), onAssociateReceive() and onServiceRequest()) 
 * and their definition is provided here. User can define these methods according to his need.
 * To create DB for RT Ion Machine Verification Services refer SQL Script RTMachineVerificationDB.sql provided in install.
 * 
 */
public class NGet_RTIonMachineVerification_SCP_Cust_ProcHandler 
{
	public static void main(String[] args) 
	{
		try
		{
			DicomConfig objDicomConfig = DicomConfig.createInstance();
			//enable logging,specify the path of the directory where log files are created.
			//User can specify any directory in place of 'c:\DCM_Logs'.
			//If no directory is defined by user to create logs then it is created in User Temp DIR.
			objDicomConfig.enableLogging(EnumLoggingLevel.INFO, "C:\\DCM_Logs");


			/*
			 * Create DataSourceImpl with ConnectionString and driver String.
			 * DataSourceImpl is default implementation of library which uses JavaDB to 
			 * find Data Elements.The user has to start javaDB server before connection
			 * if Client Server model in java DB is used.
			 * User can also provide its own implementation of IDataSource interface
			 * to find the attributes.
			 */
			String dataBasePath = "D:/SDKDatabase/RTMachineVerificationDB";
			String ConnectionString = "jdbc:derby://localhost:5050/" + dataBasePath;
			String driverString = "org.apache.derby.jdbc.ClientDriver";

			IDataSource objRTConventionalMachineVerificationdatasource = new RTMachineVerification_SourceImpl(ConnectionString,driverString);

			/*
			 * Creates RTConventionalMachineVerification_SCPHandler.
			 */
			NGetRTIonMachineVerification_SCPHandler scp = new NGetRTIonMachineVerification_SCPHandler();
			scp.addDataSource(EnumDataSource.RTMACHINEVERIFICATION,objRTConventionalMachineVerificationdatasource);
			scp.addNEventReportSCPInformation("SDK", "localhost", 9999);

			/*
			 * Created SCP session and set Default association and Process Handler on it.
			 */
			SCPSession session = new SCPSession();

			/*
			 * Initializes the service types and sets it on SCP Session
			 * EnumService Type configures SCP Session to load corresponding association context and start
			 * corresponding DIMSE Services.
			 */
			EnumServiceType []arrenumServiceType = new EnumServiceType[1];
			arrenumServiceType[0] = EnumServiceType.NGET_RT_ION_MACHINE_VERIFICATION;

			session.selectServices(arrenumServiceType);

			//Set Process Handler as the SCP TestCode
			session.setIProcessHandler(scp);
			
			/*
			 * Setting time out as 5000 milli second. It will wait 5000 mili seconds for read and write operation.
			 * If in the time specified (5000 ms) read or write operation is not performed then 
			 * session is time out.
			 */ 
			//session.setTimeOut(5000);

			//Start the Session
			session.start("SDK",9000);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}


/**
 * This class is implemented to test the RT Ion Machine Verification  SCP.
 * In order to run the following class , please refer to this link($Link) to create the environment.
 * To implement an SCP of a particular we need to do the following things :
 * To create SCP user should either has to implement class IProcessHandler (which is an interface ) or extends Process handler.
 * If test code implements process handler then user has to provide implementation of the methods declared in the interface.
 * Otherwise he can extend the process handler which contains the default implementation for processing of association and service request.
 * Create the SCPSession object which maintains the session of the SCP. 
 * Set the default association and Process handler(reference of test code) in SCPSession.
 * Its "start" method starts the SCP server.
 * When an SCU connects to the Study Management SCP then when the connection is accepted client session is created for that SCU.
 * When SCU connects to the Study Management SCP the call back on onConnect of ProcessHandler is made. Now user can get the connection parameters
 * from client session and can decide whether to accept the connection or not. To accept the connection user has to
 * pass true to acceptConnection function in ClientSession class.
 * After the connection is established the next request expected to arrive at SCP is Association request.
 * When Association request arrives, callback is made to onAssociateReceive method of ProcessHandler.
 * User now can negotiate Association request with the default association and creates AssociateAC or Reject.
 * The library provides AssociationNegotiator Class to negotiate and create appropriate response.
 * After this, when A-Release-RQ arrives , Create Release response and send it to the SCU.
 * Whenever the SCU goes down its client session is also closed or SCP can close the client session 
 * by calling close method of client session.
 */
class NGetRTIonMachineVerification_SCPHandler extends ProcessHandler
{
	/**
	 * This method notifies when a new client connection is requested. A decision is to be made whether to
	 * accept or reject the connection.  
	 * @param objClientSession  object of client session.
	 */
	public void onConnect(ClientSession objClientSession)
	{
		objClientSession.acceptConnection(true);
	}

	/**
	 * This method notifies when Association Request, Associate Release Request or Abort is received from one of the 
	 * SCUs. 
	 * If Association Request is received,
	 * 		Create Association Negotiator which negotiates the request with the existing default association and
	 * 		creates an AgreedAssociation which contains the negotiated association values. AssociationNegotiator
	 * 		returns the Association Response as AssociateAC when request is accepted or returns AssociateRJ is 
	 * 		none of the values in Association Request are acceptable.
	 * 	If Associate Release Request is received,
	 * 		Create a Associate Release Response and send the response to the SCU using the respective ClientSession.
	 *  If Abort is received,
	 *  	An Abort response must be generated and sent using ClientSession
	 *@param objClientSession  object of client session.
	 */
	public void onAssociateReceive(ClientSession objClientSession) 
	{
		//Get Association RQ
		IDIMSEAssociation objIDIMSEAssociation = objClientSession.getDIMSEAssociation();
		EnumPDUType enumPDUType = objIDIMSEAssociation.getPDUType();
		IDIMSEAssociation objAssociationRSP = null;

		//For Association Request negotiate with Default Association and generate Response
		switch(enumPDUType)
		{
		case ASSOCIATE_RQ :
		{
			System.out.println("Association Request Received");

			AssociateRQ objAssociateRQ = (AssociateRQ)objIDIMSEAssociation;

			//get the default association from Client Session.
			DefaultAssociation objDefaultAssociation = objClientSession.getDefaultAssociation();

			//Negotiate and get Response
			AssociationNegotiator objAssNegotiator = new AssociationNegotiator();
			objAssociationRSP = objAssNegotiator.negotiate(objDefaultAssociation, objAssociateRQ);

			//set agreed association in client Session.
			objClientSession.setAgreedAssociation(objAssNegotiator.getAgreedAssociation());

			//Send Response
			objClientSession.sendAssociationMessage(objAssociationRSP);
			break;
		}
		case RELEASE_RQ :
		{
			System.out.println("Release Request Received");

			//Create Release Response.
			objAssociationRSP = new AReleaseRQorRP(EnumPDUType.RELEASE_RP);

			//Send Response
			objClientSession.sendAssociationMessage(objAssociationRSP);
			System.out.println("Release Response sent");

			//Close Client Session
			objClientSession.close();
			break;
		}
		case ABORT :
		{
			System.out.println("Abort has arrived Stop Porcessing -- Association is no longer available");
		}
		}
	}

	/**
	 * This method notifies when a service related request is received.
	 * @param objClientSession  object of client session.
	 */
	public void onServiceRequest(ClientSession objClientSession)
	{
		DIMSEResponse objDResponse = null;
		EnumCommandField enumCommandType = objClientSession.getDicomMessage().getCommandType();
		if(enumCommandType.equals(EnumCommandField.N_GET_RQ))
			{
				/*
				 * Create NGetSCP get RQ from ClientSession call processRequest and pass N-GetRequest on NGetSCP
				 * receive response from NGetSCP sendResponse using ClientSession
				 */
				NGetSCP objNGetSCP = NGetSCP.createInstance(objClientSession); 
				try
				{
					System.out.println("N-Get Request Received");
					/*
					 * Process NGet Request.
					 * Set DatasourceImpl for Display System in N-Get SCP.
					 */
					objNGetSCP.setDataSourceList(getDataSourceList());
					objDResponse = objNGetSCP.processRequest(objClientSession.getDicomMessage());
					IDataSet objITempDataSet = objDResponse.getDataSet();
					display(objITempDataSet);
					/*
					 * Send the service message through Client Session.
					 */
					if(objDResponse != null)
						objClientSession.sendServiceMessage(objDResponse);
					System.out.println(" N-Get  Response Sent");
					
					/*
					 * Generate NEvent Report Request and send it to N-Event Report Server.
					 */
					
					InetSocketAddress objInetSocketAddress = new InetSocketAddress("localhost",9999);
					NEventReportSCU objNEventReportSCU = new NEventReportSCU(objInetSocketAddress);
					objNEventReportSCU.send("SDK", "SDK", DicomConstants.DCM_RT_ION_MACHINE_VERIFICATION,"1.2.840.10008.5.1.2.68.1",EnumSCEventTypeID.RT_CONVENTIONAL_MACHINE_VERIFICATION_DONE, objClientSession.getDicomMessage().getDataSet());
					System.out.println("N-Event Report Operation performed");
					
			}			
			catch(Exception ioe)
			{
				ioe.printStackTrace();
				objClientSession.close();
			}
			}
	}

	/**
	 * Closes the Client Session,
	 */
	public void onClose(ClientSession objClientSession)
	{
		objClientSession.close();
	}
	
	/*
	 * Displays the DataElements of Dataset
	 */
	private void display(IDataSet objIDataSet)
	{
		ICollectionIterator<IDataElement> objIDataSetIterator = objIDataSet.iterator();
		System.out.println("-------			---------		------");
		System.out.println("GroupNo			ElementNo		Value");
		System.out.println("-------			---------		------");

		while(objIDataSetIterator.hasNext())
		{
			IDataElement objDataElement = objIDataSetIterator.next();				

			if(!(objDataElement.getDicomValue() instanceof SQ))
			{

				System.out.println(objDataElement.getTag().getGroupNumber()+"			"+
						objDataElement.getTag().getElementNumber()+"			"+
						objDataElement.getDicomValue().toString());
			}
			else  
			{
				displaySequence((SQ)objDataElement.getDicomValue(),"> ");					
			}
		}

	}

	/**
	 * Displays the Dicom Data SQ.
	 */
	private void displaySequence(SQ objSQDataElement,String ss)
	{
		ICollectionIterator<IItem> objSQItemIterator = objSQDataElement.iterator();
		int i = 1;
		while(objSQItemIterator.hasNext())
		{
			System.out.println("ITEM :"+ i++ );
			IItem objItem = objSQItemIterator.next();
			ICollectionIterator<IDataElement> objDataElementIterator = objItem.iterator();
			while(objDataElementIterator.hasNext())
			{
				IDataElement objDataElement = objDataElementIterator.next();

				if(!(objDataElement.getDicomValue() instanceof SQ))
				{
					System.out.println(ss +objDataElement.getTag().getGroupNumber()+"			"+
							objDataElement.getTag().getElementNumber()+"			"+
							objDataElement.getDicomValue().toString());						 
				}
				else
				{
					displaySequence((SQ)objDataElement.getDicomValue(),ss+ss);
				}	 
			}
		}
	}
}
